-------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------
-- Recording when the venue has started
-------------------------------------------------------------------------------------------------
local venueStarted = false
local fish1GoingLeft = false
local fish3GoingLeft = false

local fish2Done = true
local fish4Done = true

local fish2Delay = 0
local fish4Delay = 2

local cookieStartX = 1308.0
local cookieEndX   = 1255.0
local cookieStartY = 566
local cookieEndY = 622
local cookieHidden = true
local cookieDelay = 20
local displayCookie = false

local xStartPositions = { 1308, 891, 260 }
local yStartPositions = { 566, 551, 585 }
local xEndPositions = { 1255, 841, 318 }
local yEndPositions = { 622, 636, 595 }
local positionRotations = { 0.0, 0.0, 30 }

local positionIndex = 0

registerMessageHandler("kVenueStarted", "", {},
	function()
		venueStarted = true
		displayCookie = true
	end
)

registerMessageHandler("kStarted", "FishAnim1", {"idle"},
    function()

    end
)

registerMessageHandler("kEnded", "FishAnim1", {"idle"},
    function()
	if fish1GoingLeft then	
		sendStationMsgWithParamsAndUserData("kActivate", { "StartFishAnim1Left" }, { })
		sendStationMsgWithParamsAndUserData("kActivate", { "PlayFishAnim1" }, { })
		fish1GoingLeft = false
	else
		sendStationMsgWithParamsAndUserData("kActivate", { "StartFishAnim1Right" }, { })
		sendStationMsgWithParamsAndUserData("kActivate", { "PlayFishAnim1" }, { })
		fish1GoingLeft = true
	end
    end
)

registerMessageHandler("kEnded", "FishAnim3", {"idle"},
    function()
	if fish3GoingLeft then	
		sendStationMsgWithParamsAndUserData("kActivate", { "StartFishAnim3Left" }, { })
		sendStationMsgWithParamsAndUserData("kActivate", { "PlayFishAnim3" }, { })
		fish3GoingLeft = false
	else
		sendStationMsgWithParamsAndUserData("kActivate", { "StartFishAnim3Right" }, { })
		sendStationMsgWithParamsAndUserData("kActivate", { "PlayFishAnim3" }, { })
		fish3GoingLeft = true
	end
    end
)

registerMessageHandler("kEnded", "FishAnim2", {"idle"},
    function()
	fish2Done = true
    end
)

registerMessageHandler("kEnded", "FishAnim4", {"idle"},
    function()
	fish4Done = true
    end
)

-------------------------------------------------------------------------------------------------
-- Per frame updates
-------------------------------------------------------------------------------------------------
setUpdateFunction(
	function (timeDelta)
		-- If the venue has not started, do nothing
		if not venueStarted then
			return
		end

		if displayCookie and cookieDelay > 0 then
			cookieDelay = cookieDelay - timeDelta
			if cookieDelay <= 0 then
				if cookieHidden then
					positionIndex = math.random(1,3)
					cookieHidden = false
					sendStationMsgWithParamsAndUserData("kActivate", { "CookieMove" }, { xStartPositions[positionIndex], yStartPositions[positionIndex] })
					sendStationMsgWithParamsAndUserData("kActivate", { "CookieRotate" }, { positionRotations[positionIndex] })
					sendStationMsgWithParamsAndUserData("kActivate", { "CookieTime" }, { xEndPositions[positionIndex], yEndPositions[positionIndex] })
					cookieDelay = 3.0
				else
					cookieHidden = true
					sendStationMsgWithParamsAndUserData("kActivate", { "CookieTime" }, { xStartPositions[positionIndex], yStartPositions[positionIndex] })
					cookieDelay = math.random(15,30)
				end
			end
		end

		if fish2Done then
			fish2Delay = fish2Delay - timeDelta
			if fish2Delay <= 0 then
				fish2Delay = math.random(1,5)
				fish2Done = false
				sendStationMsgWithParamsAndUserData("kActivate", { "PlayFishAnim2" }, { })
			end
		end

		if fish4Done then
			fish4Delay = fish4Delay - timeDelta
			if fish4Delay <= 0 then
				fish4Delay = math.random(1,5)
				fish4Done = false
				sendStationMsgWithParamsAndUserData("kActivate", { "PlayFishAnim4" }, { })
			end
		end
	end
)

