-------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------
-- Recording when the venue has started
-------------------------------------------------------------------------------------------------
local venueStarted = false
local autochefEnabled = isAutochefEnabled()

local currentTutorial = getCurrentTutorial()
local noTutorialActive = currentTutorial == ""

local getNoTutorialActive = function()
    local testTutorial = getCurrentTutorial()
    local noTutorialActive = testTutorial == ""
    return noTutorialActive
end

-------------------------------------------------------------------------------------------------
-- Rice Dispenser stuff
-------------------------------------------------------------------------------------------------
local riceDispenser = getStationWithId("FF_RiceDispenser")
local riceUnlocked = riceDispenser.getUnlocked()

local refillRice = function()
	sendStationMsgWithParamsAndUserData("kActivate", { "RefillRice" }, {})
end

local disableRiceLever = function()
	sendStationMsgWithParamsAndUserData("kActivate", { "NoLeverNeeded" }, {})
end

if riceUnlocked and autochefEnabled then
    registerMessageHandler("kIngredientOut", "FF_RiceDispenser", {},
        function()
            if getNoTutorialActive() then
                refillRice()
                disableRiceLever()
            end
        end
    )
end

-------------------------------------------------------------------------------------------------
-- Pork spit setup
-------------------------------------------------------------------------------------------------
local stepName = "FF_PorkSpit"
local porkSpitDispenser = getStationWithId(stepName.."Dispenser")
local maxSlot = porkSpitDispenser.getMaxSpawns()

sendStationMsgWithParamsAndUserData("kActivate", { "LuaSpitTotalCapacity",maxSlot }, {})

local availablePork = 0
local capacitySlots = {}

registerMessageHandler("kEnded",stepName.."Timer",{},
    function()
        availablePork = maxSlot
        sendStationMsgWithParamsAndUserData("kActivate", { "LuaSpitCapacitySlotsReady", availablePork }, {})
    end
)

registerMessageHandler("kIngredientOut",stepName.."Dispenser",{},
    function()
        sendStationMsgWithParamsAndUserData("kActivate", { "LuaSpitCapacitySlotOut", availablePork }, {})
        availablePork = availablePork - 1
    end
)


-------------------------------------------------------------------------------------------------
-- General Setup
-------------------------------------------------------------------------------------------------
registerMessageHandler("kVenueStarted","",{},
    function()
        venueStarted = true
        local noTutorialActive =  getNoTutorialActive()

        if autochefEnabled and noTutorialActive then
            if riceUnlocked then
                refillRice()
            end
            disableRiceLever()
        end
    end
)

registerMessageHandler("kTutorialEnded","",{},
    function()
        local noTutorialActive =  getNoTutorialActive()

        if autochefEnabled and noTutorialActive and venueStarted then
            if riceUnlocked then
                refillRice()
            end
        end
    end
)
